## pyside 1.1.2

=== debian/changelog ===
pyside (1.1.2-4) unstable; urgency=low

  [ Julian Taylor ]
  * Update install files and debian/rules to account for removal of "u"
    python3 abi flag.

 -- Didier Raboud <odyx@debian.org>  Fri, 14 Jun 2013 13:55:56 +0200

pyside (1.1.2-3) unstable; urgency=low

  * Help the sbuild apt resolver by adding phonon to Build-Depends and
    phonon-backend-null to Build-Conflicts.

 -- Didier Raboud <odyx@debian.org>  Fri, 14 Jun 2013 10:34:10 +0200

pyside (1.1.2-2) unstable; urgency=low

  * Upload to unstable

  [ Didier Raboud ]
  * Bump debhelper build-depends to 9, to align with compat.
  * Bump Standards-Version to 3.9.4 without changes needed.
  * Fix watch file.
  * Bump build-depends on shiboken to 1.1.2-4~ as -3 in unstable is
    broken.
  * Limit compilation on python3 > 3.3 as does shiboken.
  * Backport 3 commits from upstream to fix build against recent Qt.
  * Fix compilation against python3.3 in debian/rules.

  [ Jakub Wilk ]
  * Use canonical URIs for Vcs-* fields.

 -- Didier Raboud <odyx@debian.org>  Wed, 12 Jun 2013 10:50:50 +0200

pyside (1.1.2-1) experimental; urgency=low

  * New 1.1.2 "Alaursa" release.
    - Update B-Ds:
      + bump shiboken to 1.1.2.
    - Refresh patches.
  * Update control.in to match what should have been there before; also
    drop the Python3 provides.

 -- Didier Raboud <odyx@debian.org>  Wed, 05 Sep 2012 23:59:59 +0200
