=== debian/watch ===
version=3
https://qt-project.org/wiki/Get-PySide http://qt-project.org/uploads/pyside/pyside-qt\d+.\d+\+([\d\.~betarc]*).tar.bz2
